Index: server/src/clients.c
===================================================================
--- server/src/clients.c	(revision 238)
+++ server/src/clients.c	(working copy)
@@ -213,7 +213,6 @@
     if (ore_connection_table[channel].dev == NULL)
     {
         LOG_Error("no device found.");
-        free_connection(channel);
         return -ENODEV;
     }
 
@@ -264,6 +263,8 @@
 	// while we are cleaning them up. (The lock is freed down there in a rather
 	// unconventional way.
 	l4lock_lock(&ore_connection_table[handle].channel_lock);
+    
+    l4thread_shutdown(l4thread_id(ore_connection_table[handle].worker));
 
     ore_connection_table[handle].in_use         = 0;
 
Index: server/src/openclose.c
===================================================================
--- server/src/openclose.c	(revision 238)
+++ server/src/openclose.c	(working copy)
@@ -58,14 +58,10 @@
                                    CORBA_Server_Environment *_dice_corba_env)
 {
   int channel = find_channel_for_worker(*handle);
-  l4_threadid_t worker = ore_connection_table[channel].worker;
     
   LOGd_Enter(ORE_DEBUG_COMPONENTS);
   LOGd(ORE_DEBUG_COMPONENTS, "closing connection for client "l4util_idfmt, l4util_idstr(*_dice_corba_obj));
 
-  // kill worker
-  l4thread_shutdown(l4thread_id(worker));
-  
   // free connection
   free_connection(channel);
 }
